//--------------------------------------------------------------------------
//       
//      INPBYTE()  OUTBYTE()
//    BC4.5    OWL2.0
//--------------------------------------------------------------------------

#include <owl\applicat.h>
#include <owl\framewin.h>
#include <owl\dialog.h>
#include <owl\edit.h>
#include <stdio.h>
#pragma hdrstop
#include "digit_io.rh"
#include "lcard_ad.h"


TEdit* OutEd;          //    
TStatic* BitStArray[16]; //     

//--------------------------------------------------------------------------
//     TMainDialog
//--------------------------------------------------------------------------
class TMainDialog:public TDialog {
public:
   TMainDialog(TWindow* parent, TResId resId);
protected:
   void wmTimer();
   void SetupWindow();
   ~TMainDialog();
   void EvTimer(uint timerId);
DECLARE_RESPONSE_TABLE(TMainDialog);
};

DEFINE_RESPONSE_TABLE1(TMainDialog, TDialog)
  EV_WM_TIMER,
END_RESPONSE_TABLE;

TMainDialog::TMainDialog(TWindow* parent, TResId resId)
   : TWindow((TWindow*)0), TDialog(Parent, resId)
{
   OutEd=new TEdit(this, ID_OutEd);
   for (int i=0; i<16; i++)
      BitStArray[i]=new TStatic(this, ID_BitSt+i);
};

void TMainDialog::SetupWindow(void)
{
TDialog::SetupWindow();
SetTimer(ID_Timer, 100);
};


TMainDialog::~TMainDialog(void)
{
KillTimer(ID_Timer);
};


void TMainDialog::EvTimer(uint timerId)
{
char S[80];
unsigned int  iOut, iIN, Bit;
int  j;

   OutEd->GetText(S, sizeof(S));

   iOut=0;
   for (j=0; j<strlen(S); j++)
      {
      iOut=iOut << 1;
      if (S[j]=='1') iOut++;
      };

   //    () iOut   
   OUTBYTE(iOut);

   //     
   iIN=INPBYTE();

   Bit=1;
   for (j=0; j<16; j++)
      {
         if (iIN & Bit)
            BitStArray[j]->SetText("1");
         else
            BitStArray[j]->SetText("0");
         Bit=Bit << 1;
      };
 };


//--------------------------------------------------------------------------
//   TMainApp
//--------------------------------------------------------------------------
class TMainApp: public TApplication {
public:
   TMainApp(const char far* name) :TApplication(name) {};
   void InitMainWindow();
};

void TMainApp::InitMainWindow()
{
   EnableBWCC();

   TMainDialog *cp;
   cp = new TMainDialog(0, ID_MAINDIALOG);

   MainWindow =
      new TFrameWindow(
         0,
         "   -",
         cp,
         TRUE);
   MainWindow->Attr.Style &= ~(WS_MAXIMIZEBOX | WS_THICKFRAME);
};

#pragma argsused
int OwlMain( int argc, char* argv[])
{
   TMainApp app("");
   return app.Run();
};

