//--------------------------------------------------------------------------
//       
//  DMA (   DMA  )
//        (..   
// L154, L164)
//  DMA_ALL, GET_BUFFER_HALF, DMA_OFF
//    BC4.5    OWL2.0
//--------------------------------------------------------------------------

#include <owl\applicat.h>
#include <owl\framewin.h>
#include <owl\dialog.h>
#include <owl\edit.h>
#include <stdio.h>
#pragma hdrstop
#include "file_i.rh"
#include "lcard_ad.h"


TEdit *RateEd, *ChanEd, *NKadrEd, *FileNameEd;
TStatic* CounterSt;
BOOL WritingFile;

//--------------------------------------------------------------------------
//     TMainDialog
//--------------------------------------------------------------------------
class TMainDialog:public TDialog {
public:
   TMainDialog(TWindow* parent, TResId resId);
   virtual bool CanClose();
protected:
   void wmTimer();
   void cmStartWrite();
   void cmStopWrite();
   void cmCancel();
DECLARE_RESPONSE_TABLE(TMainDialog);
};

DEFINE_RESPONSE_TABLE1(TMainDialog, TDialog)
   EV_COMMAND(ID_StartWrite, cmStartWrite),
   EV_COMMAND(ID_StopWrite, cmStopWrite),
   EV_COMMAND(IDCANCEL, cmCancel),
END_RESPONSE_TABLE;

TMainDialog::TMainDialog(TWindow* parent, TResId resId)
   : TWindow((TWindow*)0), TDialog(Parent, resId)
{
  RateEd = new TEdit(this,  ID_RateEd);
  ChanEd = new TEdit(this,  ID_ChanEd);
  NKadrEd = new TEdit(this, ID_NKadrEd);
  FileNameEd = new TEdit(this, ID_FileNameEd);
  CounterSt = new TStatic(this, ID_CounterSt);

  WritingFile=0;
  LOW_POWER(0);
};


// ---------------------------------------------------------------------
//      START
// ---------------------------------------------------------------------
#define MaxChan 32

unsigned iChan, iRate, iNKadr;
int* Data;
FILE* FOut;
unsigned BlocksWritten;

void TMainDialog::cmStartWrite()
{
int Channels[MaxChan];
char S[80];
int  i;

int tmp=IsFlagSet(wfMainWindow);
    ChanEd->GetText(S, sizeof(S));
   sscanf(S, "%ud", &iChan);

   RateEd->GetText(S, sizeof(S));
   sscanf(S, "%ud", &iRate);

   NKadrEd->GetText(S, sizeof(S));
   sscanf(S, "%ud", &iNKadr);

   FileNameEd->GetText(S, sizeof(S));
   FOut = fopen(S, "wb");

   if (iRate < 5) iRate=5;
   if (iChan < 1) iChan=1;
   if (iChan > MaxChan) iChan=MaxChan;
   Data = new int[iNKadr*iChan];
   //     :
   //    1-iChan
   // !    0!!!
   for (i=0; i<iChan; i++)
      Channels[i]=CREATE_CHANNEL(i,0,0);

   //  iNKadr*2 ,      iNKadr 
   DMAALL(NULL, iNKadr*2, Channels, iChan, iRate, 1);
   WritingFile=1;
   BlocksWritten=0;
};


void TMainDialog::cmStopWrite()
{
   WritingFile=0;
   DMA_OFF();
   delete[] Data;
   fclose(FOut);
};


// ,   Cancel     CanClose()
void TMainDialog::cmCancel()
{
   CloseWindow();
};


bool TMainDialog::CanClose()
{
   return !WritingFile;
};


//--------------------------------------------------------------------------
//   TMainApp
//--------------------------------------------------------------------------
class TMainApp: public TApplication {
public:
   TMainApp(const char far* name) :TApplication(name) {};
   void InitMainWindow();
   BOOL virtual IdleAction(long);
};

//-----------------------------------------------------------------
BOOL TMainApp::IdleAction(long)
{
 char S[80];
   if (WritingFile)
      {
         GET_BUFFER_HALF(Data);
         fwrite(Data, iNKadr*iChan*2, 1, FOut);
         BlocksWritten++;

         sprintf(S,"%u",BlocksWritten);
         CounterSt->SetText(S);
      };
   return TRUE;
};


void TMainApp::InitMainWindow()
{
   EnableBWCC();

   TMainDialog *cp;
   cp = new TMainDialog(0, ID_MAINDIALOG);

   MainWindow =
      new TFrameWindow(
         0,
         "    ",
         cp,
         TRUE);
   MainWindow->Attr.Style &= ~(WS_MAXIMIZEBOX | WS_THICKFRAME);
};

#pragma argsused
int OwlMain( int argc, char* argv[])
{
   TMainApp app("");
   return app.Run();
};

