//--------------------------------------------------------------------------
//       
//      INPBYTE()  OUTBYTE()
//    BC4.5    OWL2.0
//
// !!!    ,  
// ,    def-  CODE FIXED PRELOAD PERMANENT
// ( def-).
//--------------------------------------------------------------------------

#include <owl\applicat.h>
#include <owl\framewin.h>
#include <owl\dialog.h>
#include <owl\edit.h>
#include <stdio.h>
#pragma hdrstop
#include "interrup.rh"
#include "lcard_ad.h"


TStatic* CounterSt;          //    
unsigned long Counter;


//  C-    void
//  C++  - ...
void interrupt _far Handler(...)
{
   Counter++;
   RESET_IRQ(); //   
};


//--------------------------------------------------------------------------
//     TMainDialog
//--------------------------------------------------------------------------
class TMainDialog:public TDialog {
public:
   TMainDialog(TWindow* parent, TResId resId);
protected:
   void wmTimer();
   void SetupWindow();
   ~TMainDialog();
   void EvTimer(uint timerId);
DECLARE_RESPONSE_TABLE(TMainDialog);
};

DEFINE_RESPONSE_TABLE1(TMainDialog, TDialog)
  EV_WM_TIMER,
END_RESPONSE_TABLE;

TMainDialog::TMainDialog(TWindow* parent, TResId resId)
   : TWindow((TWindow*)0), TDialog(Parent, resId)
{
   CounterSt=new TStatic(this, ID_CounterSt);


  //   100 
  //   L154, L164  2 -    INIT_SIMPLE_INTR
  //          1
  if ( (GET_BOARD_TYPE()==L154) || (GET_BOARD_TYPE()==L164) )
     INIT_SIMPLE_INTR(1000,10,Handler);
  else
     //      Rate  .
     INIT_SIMPLE_INTR(10000,0,Handler);

};

void TMainDialog::SetupWindow(void)
{
TDialog::SetupWindow();
SetTimer(ID_Timer, 100);
};


TMainDialog::~TMainDialog(void)
{
KillTimer(ID_Timer);
STOP_INTR();
};


void TMainDialog::EvTimer(uint timerId)
{
char S[80];
sprintf(S, "%lu", Counter);
CounterSt->SetText(S);
};


//--------------------------------------------------------------------------
//   TMainApp
//--------------------------------------------------------------------------
class TMainApp: public TApplication {
public:
   TMainApp(const char far* name) :TApplication(name) {};
   void InitMainWindow();
};

void TMainApp::InitMainWindow()
{
   EnableBWCC();

   TMainDialog *cp;
   cp = new TMainDialog(0, ID_MAINDIALOG);

   MainWindow =
      new TFrameWindow(
         0,
         "   -",
         cp,
         TRUE);
   MainWindow->Attr.Style &= ~(WS_MAXIMIZEBOX | WS_THICKFRAME);
};

#pragma argsused
int OwlMain( int argc, char* argv[])
{
   TMainApp app("");
   return app.Run();
};

